const fromEntries = (arrArg) => {
  // Map
  if (Object.prototype.toString.call(arrArg) === "[object Map]") {
    const resMap = {};
    for (const key of arrArg.keys()) {
      resMap[key] = arrArg.get(key);
    }
    return resMap;
  }
  // array
  if (Array.isArray(arrArg)) {
    const resArr = {}
    arrArg.map(([key, value]) => {
      resArr[key] = value
    })
    return resArr
  }
  throw "Uncaught TypeError: argument is not iterable";
}

const transformQueryString = params => {
  if (typeof params === "string") {
    const queryStrings = params.match(/[^?&]+=[^?&]+/g);

    return queryStrings ? fromEntries(
      queryStrings.map(item => item.split(/^([^=]*)=*/).filter(Boolean))
    ) : {};
  }
  if (typeof params === "object") {
    return Object.keys(params).map(key => `${key}=${params[key]}`).join("&");
  }
  alert("Parameter error")
}


const $ = selector => document.querySelector(selector);
